import { GdsDiv } from '../div/div.component';
/**
 *  A container for content representing a single entity. e.g. a contact, article, or task.
 *
 * `gds-card` inherits all properties from `gds-div`, but comes with some predefined defaults
 * and a shortcut property for specifiying different card variants.
 *
 * @element gds-card
 * @status beta
 *
 */
export declare class GdsCard extends GdsDiv {
    static styles: (import("lit").CSSResult | import("lit").CSSResult[])[];
    /**
     * Style Expression Property for the `box-shadow` property.
     *
     * Accepts shadow tokens from the design system.
     *
     * `xs`, `s`, `m`, `l`, `xl`
     *
     * @deprecated Use the `box-shadow` property instead.
     */
    shadow?: string;
    /**
     * Shortcut for setting the border, background and text color of the card to the specified color variant, such as 'primary', 'secondary', 'tertiary', etc.
     *
     * You can find all available variants in the L2 section of the [Color System documentation page](./?path=/docs/style-colors--docs)
     *
     * Supports Style Expression syntax for setting the value responsively.
     *
     */
    variant: string;
    constructor();
    render(): any;
}
