import { GdsElement } from '../../gds-element';
export type DetailsSize = 'large' | 'small';
declare const GdsDetails_base: (new (...args: any[]) => import("../../utils/mixins/declarative-layout-mixins").SizeXProps) & (new (...args: any[]) => import("../../utils/mixins/declarative-layout-mixins").MarginProps) & (new (...args: any[]) => import("../../utils/mixins/declarative-layout-mixins").LayoutChildProps) & typeof GdsElement;
/**
 * Details component that provides collapsible content sections.
 *
 * @element gds-details
 * @status beta
 *
 * @slot - Default slot for details content
 * @event gds-ui-state - Fired when details opens or closes
 *
 * @example
 * ```html
 * <gds-details summary="Section Title">
 *   <p>Details content here</p>
 * </gds-details>
 * ```
 */
export declare class GdsDetails extends GdsDetails_base {
    #private;
    static styles: (import("lit").CSSResult | import("lit").CSSResult[])[];
    /**
     * The summary text displayed in the details header
     */
    summary: string;
    /**
     * Group identifier for details behavior synchronization
     */
    name: string;
    /**
     * Controls the expanded state of the details
     */
    open: boolean;
    /**
     * Controls the size variant of the details
     */
    size: DetailsSize;
    private _content?;
    private _openIconSlot?;
    private _closedIconSlot?;
    private __handleOpenChange;
    render(): any;
}
export {};
