import {
  __decorateClass
} from "../../chunks/chunk.QTSIPXV3.js";
import { nothing } from "lit";
import { property } from "lit/decorators.js";
import { GdsElement } from "../../gds-element.js";
import { tokens } from "../../tokens.style.js";
import { styleExpressionProperty } from "../../utils/decorators/style-expression-property.js";
import { forColorTokens } from "../../utils/helpers/index.js";
import {
  gdsCustomElement,
  html
} from "../../utils/helpers/custom-element-scoping.js";
import DividerCSS from "./divider.style.js";
let GdsDivider = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.level = "2";
    this.role = null;
  }
  render() {
    return html`<hr role=${this.role || nothing} />`;
  }
};
GdsDivider.styles = [tokens, DividerCSS];
__decorateClass([
  property()
], GdsDivider.prototype, "level", 2);
__decorateClass([
  styleExpressionProperty(forColorTokens("border"))
], GdsDivider.prototype, "color", 2);
__decorateClass([
  styleExpressionProperty({
    property: "--_size",
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsDivider.prototype, "size", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDivider.prototype, "opacity", 2);
__decorateClass([
  property()
], GdsDivider.prototype, "role", 2);
GdsDivider = __decorateClass([
  gdsCustomElement("gds-divider")
], GdsDivider);
export {
  GdsDivider
};
