import { PropertyValues } from 'lit';
import { GdsFormattedText } from '../formatted-text';
import { AccountFormats } from './account-formatter';
/**
 * @element gds-formatted-account
 * @status beta
 *
 * `gds-formatted-account` extends `gds-text` and formats the account to the desired format.
 *
 * @example
 * <gds-formatted-account
 *   account="54400023423">
 * </gds-formatted-account>
 */
export declare class GdsFormattedAccount extends GdsFormattedText {
    /**
     * The account number or identifier to display.
     * For format 'seb-account', it needs to be 11 characters.
     * */
    account?: number | string;
    /**
     * Specifies the account format.
     * @default 'seb-account'
     */
    protected format: AccountFormats;
    get formattedValue(): string;
    protected firstUpdated(_changedProperties: PropertyValues): void;
}
