import {
  __decorateClass
} from "../../../chunks/chunk.QTSIPXV3.js";
import { property } from "lit/decorators.js";
import { gdsCustomElement } from "../../../utils/helpers/custom-element-scoping.js";
import { GdsFormattedText } from "../formatted-text.js";
import { accountsFormats } from "./account-formatter.js";
let GdsFormattedAccount = class extends GdsFormattedText {
  constructor() {
    super(...arguments);
    this.format = "seb-account";
  }
  get formattedValue() {
    return accountsFormats[this.format](this.account);
  }
  firstUpdated(_changedProperties) {
    super.firstUpdated(_changedProperties);
    if (!this.account && this.textContent) {
      this.account = this.textContent;
    }
  }
};
__decorateClass([
  property()
], GdsFormattedAccount.prototype, "account", 2);
__decorateClass([
  property({ type: String })
], GdsFormattedAccount.prototype, "format", 2);
GdsFormattedAccount = __decorateClass([
  gdsCustomElement("gds-formatted-account")
], GdsFormattedAccount);
export {
  GdsFormattedAccount
};
