import {
  __decorateClass
} from "../../chunks/chunk.QTSIPXV3.js";
import { property } from "lit/decorators.js";
import { GdsElement } from "../../gds-element.js";
import { tokens } from "../../tokens.style.js";
import { styleExpressionProperty } from "../../utils/decorators/style-expression-property.js";
import {
  gdsCustomElement,
  html
} from "../../utils/helpers/custom-element-scoping.js";
import {
  withPositioningProps,
  withSizeXProps,
  withSizeYProps
} from "../../utils/mixins/declarative-layout-mixins.js";
import IMGCSS from "./img.style.js";
let GdsImg = class extends withPositioningProps(
  withSizeXProps(withSizeYProps(GdsElement))
) {
  render() {
    return html`<img src="${this.src}" alt="${this.alt}" />`;
  }
};
GdsImg.styles = [tokens, IMGCSS];
__decorateClass([
  styleExpressionProperty()
], GdsImg.prototype, "aspect-ratio", 2);
__decorateClass([
  styleExpressionProperty({
    property: "border-radius",
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsImg.prototype, "border-radius", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "img"
  })
], GdsImg.prototype, "object-fit", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "img"
  })
], GdsImg.prototype, "object-position", 2);
__decorateClass([
  property()
], GdsImg.prototype, "src", 2);
__decorateClass([
  property()
], GdsImg.prototype, "alt", 2);
GdsImg = __decorateClass([
  gdsCustomElement("gds-img")
], GdsImg);
export {
  GdsImg
};
