import { GdsElement } from '../../gds-element';
/**
 * @element gds-radio
 * @status beta
 *
 * @event gds-radio-change - Dispatched when the radio button is checked.
 */
export declare class GdsRadio extends GdsElement {
    #private;
    static styles: import("lit").CSSResult[];
    /**
     * The label displayed next to the radio button.
     */
    label: string;
    /**
     * The supporting text displayed below the label.
     * This text provides additional context or information to the user.
     */
    supportingText: string;
    /**
     * The value of the radio button.
     */
    value: string;
    /**
     * Whether the radio button is checked or not.
     */
    checked: boolean;
    /**
     * Whether the radio button is disabled or not.
     */
    disabled: boolean;
    /**
     * Whether the radio button is invalid or not.
     */
    invalid: boolean;
    private _isFocused;
    constructor();
    connectedCallback(): void;
    private _updateAriaState;
    updated(changedProperties: Map<string, unknown>): void;
    private _handleDisabledChange;
    render(): any;
}
