import { GdsFormattedDate } from '../../formatted-text/date/formatted-date.component';
/**
 * @element gds-sensitive-date
 *
 * @status beta
 *
 * [Source code](https://github.com/seb-oss/green/tree/main/libs/core/src/components/sensitive/date)
 *
 * GdsSensitiveDate is used to display dates that need to be hidden
 *
 * The component renders the formatted date and conditionally hides it based on the `hide` property.
 *
 * @example
 * <gds-sensitive-date
 *   hide
 *   value="2025/1/1"
 *   locale="sv-SE">
 * </gds-sensitive-date>
 */
export declare class GdsSensitiveDate extends GdsFormattedDate {
    /**
     * When true, hides the sensitive date.
     * @default false
     */
    hide: boolean;
    render(): any;
}
