import { PropertyValues } from 'lit';
import { GdsFormattedNumber } from '../../formatted-text/number/formatted-number.component';
/**
 * @element gds-sensitive-number
 *
 * @status beta
 *
 * [Source code](https://github.com/seb-oss/green/tree/main/libs/core/src/components/sensitiv/number)
 *
 * GdsSensitiveNumber is used to display numbers that need to be hidden,
 * helping to protect sensitive numerical data.
 *
 * The component renders the formatted number and conditionally hides it based on the `hide` property.
 *
 * @example
 * <gds-sensitive-number
 *   hide
 *   value="1234"
 *   locale="sv-SE">
 * </gds-sensitive-number>
 */
export declare class GdsSensitiveNumber extends GdsFormattedNumber {
    /**
     * When true, hides the sensitive number.
     * @default false
     */
    hide: boolean;
    get formattedValue(): string;
    render(): any;
    protected updated(changedProperties: PropertyValues): void;
}
