import { GdsElement } from '../../gds-element';
/**
 * @element gds-theme
 * @status beta
 *
 * A component that provides CSS variables for a part of the DOM tree.
 * Every descendant of this component will inherit the CSS variables
 * provided by the theme set on this component.
 *
 * @slot - The content to apply the theme to.
 *
 * @event gds-color-scheme-changed - Fired when the color scheme changes.
 * @event gds-design-version-changed - Fired when the design version changes.
 *
 */
export declare class GdsTheme extends GdsElement {
    static styles: (import("lit").CSSResult | import("lit").CSSResult[])[];
    /**
     * The theme mode. Can be `light`, `dark`, or `auto`.
     */
    colorScheme: 'light' | 'dark' | 'auto';
    /**
     * The design version to use. Can be `16` or `23`.
     */
    designVersion: '2016' | '2023';
    connectedCallback(): void;
    render(): any;
    private _onColorSchemeChange;
    private _onDesignVersionChange;
}
