import {
  __decorateClass
} from "./chunks/chunk.QTSIPXV3.js";
import { LitElement } from "lit";
import { state } from "lit/decorators.js";
import { DynamicStylesController } from "./utils/controllers/dynamic-styles-controller.js";
import "reflect-metadata";
class GdsElement extends LitElement {
  constructor() {
    super();
    this._isUsingTransitionalStyles = false;
    this._dynamicStylesController = new DynamicStylesController(this);
  }
  /**
   * Defines the custom element in the custom element registry.
   * This method needs to be called once before the element can be used.
   */
  static define() {
    return void 0;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("gds-element", this.gdsElementName?.toString() || "");
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.dispatchEvent(
      new CustomEvent("gds-element-disconnected", {
        bubbles: true,
        composed: false
      })
    );
  }
}
/**
 * Whether the element is defined in the custom element registry.
 */
GdsElement.isDefined = false;
__decorateClass([
  state()
], GdsElement.prototype, "_isUsingTransitionalStyles", 2);
export {
  GdsElement
};
