import {
  __decorateClass
} from "../../chunks/chunk.QTSIPXV3.js";
import { html, unsafeCSS } from "lit";
import { query } from "lit/decorators.js";
import { GdsElement } from "../../gds-element.js";
import { gdsCustomElement } from "../../scoping.js";
import { tokens } from "../../tokens.style.js";
import styles from "./ripple.styles.scss.js";
let GdsRipple = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.onmousedown = (e) => {
      const target = e.target;
      const rect = target.getBoundingClientRect();
      const rippleEl = this._rippleEl;
      if (rippleEl) {
        rippleEl.classList.remove("gds-ripple-effect");
        this.style.setProperty("--gds-ripple-top", `${e.clientY - rect.top}px`);
        this.style.setProperty("--gds-ripple-left", `${e.clientX - rect.left}px`);
        setTimeout(() => {
          rippleEl.classList.add("gds-ripple-effect");
        }, 20);
      }
    };
  }
  render() {
    return html`<div></div>`;
  }
};
GdsRipple.styles = [tokens, unsafeCSS(styles)];
__decorateClass([
  query("div")
], GdsRipple.prototype, "_rippleEl", 2);
GdsRipple = __decorateClass([
  gdsCustomElement("gds-ripple")
], GdsRipple);
export {
  GdsRipple
};
