import "./chunks/chunk.QTSIPXV3.js";
import { css, unsafeCSS } from "lit";
import colorsDark from "./tokens/dark.css.js";
import colorsLight from "./tokens/light.css.js";
import motionTokens from "./tokens/motion.css.js";
import shadowTokens from "./tokens/shadow.css.js";
import sizeTokens from "./tokens/size.css.js";
import textTokens from "./tokens/text.css.js";
import { GlobalStylesRegistry } from "./utils/global-styles.js";
const tokens = [
  unsafeCSS(sizeTokens),
  unsafeCSS(textTokens),
  unsafeCSS(motionTokens),
  unsafeCSS(shadowTokens)
];
GlobalStylesRegistry.instance.injectGlobalStyles(
  "root-tokens",
  css`
    :root,
    :root[gds-theme='light'] {
      ${unsafeCSS(colorsLight)}
    }
    :root[gds-theme='dark'] {
      ${unsafeCSS(colorsDark)}
    }
  `
);
export {
  colorsDark,
  colorsLight,
  tokens
};
