/**
 * A template tag that strips whitespace from the template. In some situatiuons
 * whitespace can cause inconsistent gap behaviour when `<slot>` is used with `flexbox`
 * elements. This template tag can be used to strip whitespace from the template in these
 * cases.
 *
 * Use with caution and only when necessary.
 *
 * @internal
 * @param extendedTag Template literal tag to extend
 * @returns A new template literal tag that strips whitespace from the template
 */
export declare function stripWhitespace(extendedTag: (strings: TemplateStringsArray, ...values: any[]) => any): (strings: TemplateStringsArray, ...values: any[]) => any;
