import { StyleExpressionPropertyOptions } from '../decorators/style-expression-property';
/**
 * This type expresses allowed color levels in the GDS color system.
 */
export type GdsColorLevel = '1' | '2' | '3';
/**
 * Parse color token value to a css var expression. If slash is present,
 * the value after the slash vill be used for transparency.
 *
 * @param value The color token name
 * @param context The context, such as content, background, border, etc.
 * @param level The level of the color. Can be 1, 2 or 3
 */
export declare function parseColorValue(value: string, context: string, level: GdsColorLevel): string;
/**
 * Create options for style expression properties that expect color tokens.
 *
 * @param context The context, such as content, background, border, etc.
 */
export declare function forColorTokens(context: string): StyleExpressionPropertyOptions;
/**
 * Create options for style expression properties that expect space tokens.
 */
export declare const forSpaceTokens: StyleExpressionPropertyOptions;
/**
 * Create options for style expression properties that expect space tokens.
 */
export declare const forSpaceTokensAndCustomValues: StyleExpressionPropertyOptions;
/**
 * Create options for style expression properties that expect space tokens.
 * This version supports negative values.
 */
export declare const forSpaceTokensSupportingNegative: StyleExpressionPropertyOptions;
