import "../../chunks/chunk.QTSIPXV3.js";
const Focusable = (superClass) => {
  class HighlightableElement extends superClass {
    constructor() {
      super(...arguments);
      this.onblur = (e) => {
        this.setAttribute("tabindex", "-1");
        this.dispatchEvent(
          new FocusEvent("gds-blur", {
            bubbles: true,
            composed: true,
            relatedTarget: e.relatedTarget
          })
        );
      };
      this.onfocus = (e) => {
        this.dispatchEvent(
          new FocusEvent("gds-focus", {
            bubbles: true,
            composed: true,
            relatedTarget: e.relatedTarget
          })
        );
      };
    }
    focus(options) {
      this.setAttribute("tabindex", "0");
      super.focus(options);
    }
  }
  return HighlightableElement;
};
export {
  Focusable
};
